Attribute VB_Name = "Module1"
Option Explicit

Public bEncrypt As Boolean
Public nKey As Integer
Const ky = 64


Public Function EncryptString(ByVal sString As String) As String
     Dim i, nCh, nCh2 As Integer
     Dim sReturn, sCh As String
     
     sReturn = ""
     If Len(sString) > 0 Then
        For i = 1 To Len(sString)
             nCh = Asc(Mid(sString, i, 1))
             sCh = Chr(nCh)
             If nCh >= Asc("A") And nCh <= Asc("z") Then
'                 nCh2 = (nCh + ky) Xor 255
                 nCh2 = (nCh + nKey) Xor 255
                 sCh = Chr(nCh2)
                 sReturn = sReturn & Chr(253) & sCh
             Else
                 sReturn = sReturn & sCh
             End If
        Next i
     End If
     EncryptString = sReturn
End Function

Public Function DecryptString(ByVal sString As String) As String
     Dim i, nCh, nCh2 As Integer
     Dim sReturn, sCh As String
     Dim bLetter As Boolean
     
     sReturn = ""
     bLetter = False
     If Len(sString) > 0 Then
        For i = 1 To Len(sString)
           nCh = Asc(Mid(sString, i, 1))
           sCh = Chr(nCh)
           If bLetter = True Then
               nCh2 = (nCh Xor 255)
               nCh2 = nCh2 - nKey
               sCh = Chr(nCh2)
               sReturn = sReturn & sCh
               bLetter = False
           Else
               If nCh = 253 Then
                   bLetter = True
               Else
                   bLetter = False
                   sReturn = sReturn & sCh
               End If
           End If
        Next i
     End If
     DecryptString = sReturn
End Function

Public Sub ProcessFile(SourceFileName As String, DestinationFileName As String, Encrypt As Boolean, sKeyfile As String, sPassword As String)
    Dim FileNr1, FileNr2, KeyFileNr, O1, O2 As Integer
    Dim sString, sKey As String
    Dim i As Long
    
    bEncrypt = Encrypt
    O1 = 0
    O2 = 0
'    On Error GoTo ErrorTrap
    KeyFileNr = FreeFile
    Open sKeyfile For Input As #KeyFileNr
    For i = 1 To GetPrivateKey(sPassword)
        If Not EOF(KeyFileNr) Then
            Line Input #KeyFileNr, sKey
        Else
            Close #KeyFileNr
            KeyFileNr = FreeFile
            Open sKeyfile For Input As #KeyFileNr
        End If
    Next i
    
    FileNr1 = FreeFile
    Open SourceFileName For Input As #FileNr1
    FileNr2 = FreeFile
    O1 = 1
    Open DestinationFileName For Output Shared As #FileNr2
    O2 = 2
    
    While Not EOF(FileNr1)
        Line Input #FileNr1, sString
            
        For i = 1 To GetPrivateKey(sPassword)
            If Not EOF(KeyFileNr) Then
                Line Input #KeyFileNr, sKey
            Else
                Close #KeyFileNr
                KeyFileNr = FreeFile
                Open sKeyfile For Input As #KeyFileNr
            End If
        Next i
        
        If Not EOF(KeyFileNr) Then
            Line Input #KeyFileNr, sKey
            nKey = Val(sKey)
        Else
            Close #KeyFileNr
            KeyFileNr = FreeFile
            Open sKeyfile For Input As #KeyFileNr
        End If
        If bEncrypt = True Then
            sString = EncryptString(sString)
        Else
            sString = DecryptString(sString)
        End If
        Print #FileNr2, sString
    Wend
    
    Close #KeyFileNr
    Close #FileNr1
    Close #FileNr2
    Exit Sub
'ErrorTrap:
        MsgBox "Error " & Err.Number & " " & Err.Description
        If O1 = 1 Then Close #FileNr1
        If O2 = 1 Then Close #FileNr2
End Sub

Public Sub GenerateEncryptionKeyFile(SourceFileName As String, NrOfKeys As Long)
    Dim FileNr1 As Integer
    Dim i As Long
    Dim sString As String
    
    
'    On Error GoTo ErrorTrap
    FileNr1 = FreeFile
    Open SourceFileName For Output Shared As #FileNr1
    Randomize
    For i = 1 To NrOfKeys
        Print #FileNr1, Int((ky * Rnd) + 1)
    Next i
    
    Close #FileNr1
    Exit Sub
'ErrorTrap:
        MsgBox "Error " & Err.Number & " " & Err.Description
End Sub

Public Function GetPrivateKey(sPassword As String) As Long
    Dim i, nAve, n, nPKey As Integer
    
    
    nPKey = 0
    If Len(sPassword) > 0 Then
        For i = 1 To Len(sPassword)
            nPKey = nPKey + Asc(Mid(sPassword, i, 1))
            n = n + 1
        Next i
        nAve = Int(nPKey / n)
        nPKey = nPKey + nAve
    End If
    
    GetPrivateKey = nPKey
End Function

